package com.jsql.model.accessible;

import java.util.Arrays;
import java.util.Optional;

public enum ExploitMethod {
    AUTO("KEY_LABEL_AUTO", "KEY_TOOLTIP_AUTO"),
    QUERY_BODY("KEY_LABEL_QUERY_BODY", "KEY_TOOLTIP_QUERY_BODY"),
    TEMP_TABLE("KEY_LABEL_TEMP_TABLE", "KEY_TOOLTIP_TEMP_TABLE"),
    NETSHARE("KEY_LABEL_NETSHARE", "KEY_TOOLTIP_NETSHARE");
    private final String keyLabel;
    private final String keyTooltip;
    ExploitMethod(String keyLabel, String keyTooltip) {
        this.keyLabel = keyLabel;
        this.keyTooltip = keyTooltip;
    }
    public static Optional<ExploitMethod> forName(String label) {  // used with toString() giving enum name
        return Arrays.stream(ExploitMethod.values())
        .filter(action -> label.equals(action.name()))
        .findFirst();
    }

    public String getKeyLabel() {
        return this.keyLabel;
    }

    public String getKeyTooltip() {
        return this.keyTooltip;
    }
}